;
; Auteur Bruno Berteau
; site web : bberteau.free.fr
; mel: web.bberteau@free.fr
; Ce programme peut tre librement modifier et distribu
;

.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib

WM_SHELLNOTIFY equ WM_USER+5
IDI_TRAY equ 0
IDM_MESS equ 1000
IDM_NAVI equ 1010
IDM_COMP equ 1020
IDM_QUIT equ 1030
IDM_APRO equ 1040

WndProc proto :DWORD,:DWORD,:DWORD,:DWORD
Exec    proto :DWORD

.data
dlgname     db "MAIN",0 
TxtTray     db "Cliquez pour le menu",0
; Menu
Messanger   db "&Messanger",0
Navigator   db "&Navigator",0
Composer    db "&Composer",0
Sortie      db "&Quitter",0
APropos     db "&A Propos de N. Manager",0

; commande  passer pour lancer netscape
CMD         db "netscape", 0

; paramtres de netscape

PNavi       db "-browser",0
PComp       db "-edit",0
PMess       db "-mail",0
 
.data?
hInstance	dd ?
note NOTIFYICONDATA <>
hPopupMenu	dd ?
hIco        dd ?

.code
start:
	invoke GetModuleHandle, NULL ; rcupre le "handle" du programme
                                   ; le handle est un nombre qui identifie un  programme
                                   ; ou tout autre objet cre dans un application
	mov    hInstance,eax
	invoke LoadIcon, hInstance, 101 ; on charge l'icone dans le programme
                                      ; 101 est le numro donn  l'icone dans le fichier rsrc.rc
	mov hIco,eax                    ; sauve le handle de l'icone dans hIco
	invoke MessageBeep,4 ; bip !
      ; on crer la fentre "A propos" qui aura comme procdure WndProc
	invoke DialogBoxParam,hInstance,ADDR dlgname,0,ADDR WndProc,0
	invoke ExitProcess,0

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD ; procdure qui va grer les messages envoys  la fentre
LOCAL pt:POINT
	.if uMsg == WM_INITDIALOG ; message d'initialisation de la "DialogBox"
        	invoke SetTimer,hWin,200,2000,NULL ; cre un timer pour afficher la fentre pendant 2000ms au lancement
                                               ; 200 est l'identifiant du timer
		invoke LoadIcon,hInstance,101
		push eax
		invoke SendMessage,hWin,WM_SETICON,TRUE,eax
            ; crer un menu pop up et ajouter les entres
            invoke CreatePopupMenu
            mov hPopupMenu,eax
            invoke AppendMenu,hPopupMenu,MF_STRING,IDM_APRO,addr APropos
            invoke AppendMenu,hPopupMenu,MF_SEPARATOR,0,0
            invoke AppendMenu,hPopupMenu,MF_STRING,IDM_COMP,addr Composer
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_MESS,addr Messanger
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_NAVI,addr Navigator
            invoke AppendMenu,hPopupMenu,MF_SEPARATOR,0,0
            invoke AppendMenu,hPopupMenu,MF_STRING,IDM_QUIT,addr Sortie

            ; On remplit la structure
            mov note.cbSize,sizeof NOTIFYICONDATA
            push hWin
            pop note.hwnd
            mov note.uID,0
            mov note.uFlags,NIF_ICON+NIF_MESSAGE+NIF_TIP
            mov note.uCallbackMessage,WM_SHELLNOTIFY        
            pop note.hIcon                                  
            invoke lstrcpy,addr note.szTip,addr TxtTray
            invoke Shell_NotifyIcon,NIM_ADD,addr note
	.elseif uMsg == WM_CLOSE
            invoke ShowWindow,hWin,SW_HIDE               ; cache la fentre
            xor eax,eax
            ret
	.elseif uMsg == WM_COMMAND
		.if wParam == IDM_APRO
		  invoke ShowWindow,hWin,SW_RESTORE                ; affiche la fentre "A propos"
		.elseif wParam == IDM_QUIT
              	invoke DestroyMenu,hPopupMenu                ; destrucion du menu
			invoke Shell_NotifyIcon,NIM_DELETE,addr note ; Effacer l'icone
              	invoke EndDialog,hWin,0
              	ret
            .elseif wParam == IDM_COMP ; Clic sur Composer
              	invoke Exec, offset PComp
            .elseif wParam == IDM_NAVI ; Idem sur Navigateur
              	invoke Exec, offset PNavi
            .elseif wParam == IDM_MESS ; Messenger
              	invoke Exec, offset PMess
		.endif
              	xor eax,eax
              	ret
	.elseif uMsg == WM_TIMER ; Message du timer
            invoke ShowWindow,hWin,SW_HIDE ; on cache la fentre car le programme doit continue  tourner
            invoke KillTimer,hWin,200 ; on a plus besoin du timer donc on l'limine
            xor eax,eax
            ret
	.elseif uMsg == WM_SHELLNOTIFY                             ;callback message
		.if wParam==0
			.if lParam==WM_RBUTTONDOWN || lParam==WM_LBUTTONDOWN ; affiche le menu si clic bouton droit ou gauche
                    	invoke GetCursorPos,addr pt
			  	invoke SetForegroundWindow,hWin
                    	invoke TrackPopupMenu,hPopupMenu,TPM_RIGHTALIGN or TPM_RIGHTBUTTON,pt.x,pt.y,NULL,hWin,NULL
			  	invoke PostMessage,hWin,WM_NULL,0,0  
			.elseif lParam==WM_LBUTTONDBLCLK               ; double-clic affiche la fentre "A propos"
                    	invoke SendMessage,hWin,WM_COMMAND,IDM_APRO,0
			.endif
		.endif
      .endif
xor eax,eax
    ret 
WndProc endp

Exec proc PARAM:DWORD
    invoke ShellExecute,0,0, offset CMD,PARAM,0,SW_SHOWMAXIMIZED ; dmarre netscape avec l'argument PARAM
    ret
Exec endp

end start
